# Client
kill @e[type=minecraft:item,nbt={Item:{tag:{stat:"kill_count"}}}]
## Gui (inventory1)
execute as @a[tag=el_fuego.ability,gamemode=!creative,gamemode=!spectator] at @s run function cb_client:guis/inventory_1/gui/main
execute as @a[tag=el_fuego.ability,gamemode=!survival,gamemode=!spectator,gamemode=!creative] at @s run execute as @e[type=item,sort=nearest,distance=..3] at @s run data merge entity @s {PickupDelay:2s}
kill @e[type=minecraft:item,nbt={Item:{tag:{objd:{gui:{inventory1:1b}}}}}]

## Gui (inventory2)
execute as @a[tag=necromancer.ability,gamemode=!creative,gamemode=!spectator] at @s run function cb_client:guis/inventory_2/gui/main
execute as @a[tag=necromancer.ability,gamemode=!survival,gamemode=!spectator,gamemode=!creative] at @s run execute as @e[type=item,sort=nearest,distance=..3] at @s run data merge entity @s {PickupDelay:2s}
kill @e[type=minecraft:item,nbt={Item:{tag:{objd:{gui:{inventory2:1b}}}}}]

## Gui (inventory3)
execute as @a[tag=harmony_healer.ability,gamemode=!creative,gamemode=!spectator] at @s run function cb_client:guis/inventory_3/gui/main
execute as @a[tag=harmony_healer.ability,gamemode=!survival,gamemode=!spectator,gamemode=!creative] at @s run execute as @e[type=item,sort=nearest,distance=..3] at @s run data merge entity @s {PickupDelay:2s}
kill @e[type=minecraft:item,nbt={Item:{tag:{objd:{gui:{inventory3:1b}}}}}]

## Gui (handitem1)
execute as @a[nbt={SelectedItem:{tag:{cb_mod:"music_player"}}}] run tag @s add objd_has_gui_item.handitem1
execute as @e[type=minecraft:chest_minecart,tag=objd_gui_container.handitem1] at @s unless entity @e[distance=..8,tag=objd_has_gui_item.handitem1] run function cb_client:guis/handitem_1/gui/removecart
execute as @e[tag=objd_had_gui_item.handitem1,tag=!objd_has_gui_item.handitem1] run tag @s remove objd_had_gui_item.handitem1
execute as @a[tag=objd_has_gui_item.handitem1,tag=!objd_had_gui_item.handitem1] at @s anchored eyes run function cb_client:guis/handitem_1/gui/summoncart
execute as @a[tag=objd_has_gui_item.handitem1] at @s anchored eyes run function cb_client:guis/handitem_1/objd/execute
execute as @e[type=minecraft:chest_minecart,tag=objd_gui_container.handitem1] at @s run function cb_client:guis/handitem_1/gui/main
kill @e[type=minecraft:item,nbt={Item:{tag:{objd:{gui:{handitem1:1b}}}}}]
kill @e[type=minecraft:item,nbt={Item:{id:"minecraft:chest_minecart",tag:{display:{Name:'{"text":"֍","extra":[{"text":"Chose any Song","font":"minecraft:default"}],"font":"cb_ids:_u058d"}'}}}}]
clear @a[nbt=!{SelectedItem:{tag:{cb_mod:"music_player"}}}] #cb_client:guis/handitem_1/all{objd:{gui:{handitem:1b}}}
execute as @a[tag=objd_had_gui_item.handitem1] at @s unless entity @e[tag=objd_gui_container.handitem1,distance=..1.6,sort=nearest] run function cb_client:guis/handitem_1/gui/summoncart

execute as @a at @s store result score @s objd_gui_carrier_count.handitem1 run execute if entity @e[tag=objd_gui_container.handitem1,distance=..2]
execute as @a[tag=objd_had_gui_item.handitem1] at @s if score @s objd_gui_carrier_count.handitem1 matches 2.. run execute as @e[tag=objd_gui_container.handitem1,distance=..2,limit=1,sort=nearest] at @s run function cb_client:guis/handitem_1/gui/removecart

## Gui (settings)
execute as @a at @s unless score @s settings matches 1.. run scoreboard players enable @s settings
execute as @a at @s run function cb_client:guis/settings/gui_toggle_on
execute as @a[scores={settings=1..}] run tag @s add objd_has_gui_item.settings
execute as @a[scores={settings=1..}] at @s unless score @s gui.settings.motion.time_passed matches 1.. run function cb_client:guis/settings/gui_toggle_off
execute as @e[type=minecraft:chest_minecart,tag=objd_gui_container.settings] at @s unless entity @e[distance=..8,tag=objd_has_gui_item.settings] run function cb_client:guis/settings/gui/removecart
execute as @e[tag=objd_had_gui_item.settings,tag=!objd_has_gui_item.settings] run tag @s remove objd_had_gui_item.settings
execute as @a[tag=objd_has_gui_item.settings,tag=!objd_had_gui_item.settings] at @s anchored eyes run function cb_client:guis/settings/gui/summoncart
execute as @a[tag=objd_has_gui_item.settings] at @s anchored eyes run function cb_client:guis/settings/objd/execute
execute as @e[type=minecraft:chest_minecart,tag=objd_gui_container.settings] at @s run function cb_client:guis/settings/gui/main

execute as @a[scores={configured_player_movement.boolean.true=1..}] at @s run attribute @s generic.attack_speed base set 8
execute as @a[scores={configured_player_movement.boolean.false=1..}] at @s run attribute @s generic.attack_speed base set 4

kill @e[type=minecraft:item,nbt={Item:{tag:{objd:{gui:{settings1:1b}}}}}]
kill @e[type=minecraft:item,nbt={Item:{id:"minecraft:chest_minecart",tag:{display:{Name:'{"text":"წ","extra":[{"text":"Settings","font":"minecraft:default"}],"font":"cb_ids:_u10ec"}'}}}}]
clear @a #cb_client:guis/settings/all{objd:{gui:{settings:1b}}}
execute as @a[tag=objd_had_gui_item.settings] at @s unless entity @e[tag=objd_gui_container.settings,distance=..1.6,sort=nearest] run function cb_client:guis/settings/gui/summoncart


#Minecart fix
execute as @e[type=#minecarts,tag=!.transparent] at @s run execute unless entity @e[type=armor_stand,distance=..1,sort=nearest,tag=entity_loader.minecart] run summon armor_stand ~ ~ ~ {Tags:[entity_loader.minecart],ArmorItems:[{id:"minecraft:stick",Count:1,tag:{CustomModelData:6648218}},{},{id:"minecraft:stick",Count:1,tag:{CustomModelData:6648218}},{id:"minecraft:stick",Count:1,tag:{CustomModelData:6648218}}],Marker:1,Invisible:1,Invulnerable:1,NoGravity:1,NoBasePlate:1}
execute as @e[type=#minecarts,tag=!.transparent] at @s run tp @e[type=armor_stand,distance=..1,sort=nearest,tag=entity_loader.minecart,limit=1] @s
execute as @e[tag=entity_loader.minecart] at @s unless entity @e[type=#minecarts,tag=!.transparent,distance=..1,sort=nearest] run kill @s

# Relative World & Custom Gamerules
execute store result score #relative_world default.day_time run time query daytime

#Simple Particle Mode
scoreboard players remove @e[scores={simple_particle_mode.boolean_cooldown=1..}] simple_particle_mode.boolean_cooldown 1
scoreboard players reset @e[scores={simple_particle_mode.boolean_cooldown=0}] simple_particle_mode.boolean_cooldown

## AFK DET


#El Fuego
execute as @a[tag=el_fuego.ability] at @s run function cb_mod:afk_det/afk.el_fuego
execute as @a[tag=el_fuego.ability] at @s if score @s afk.time_passed = @s afkTimeLimit run function cb_mod:afk_det/afk_result.el_fuego
execute as @a[tag=el_fuego.ability,tag=el_fuego.afk] at @s run execute as @e[sort=nearest,distance=..1,tag=el_fuego.afk_marker,limit=1] at @s run particle small_flame ^ ^0.5 ^1
execute as @a[tag=el_fuego.ability,tag=el_fuego.afk] at @s run execute as @e[sort=nearest,distance=..1,tag=el_fuego.afk_marker,limit=1] at @s run tp @s ~ ~ ~ facing ^0.2 ^ ^1
execute as @a[tag=el_fuego.ability,tag=el_fuego.afk] at @s run effect give @s resistance 1 99 true
execute as @a[tag=el_fuego.ability,tag=el_fuego.afk] at @s run effect give @s weakness 1 99 true
execute as @a[tag=el_fuego.ability,tag=el_fuego.afk] at @s run effect give @s mining_fatigue 1 99 true

#Necromancer
execute as @a[tag=necromancer.ability] at @s run function cb_mod:afk_det/afk.necromancer
execute as @a[tag=necromancer.ability] at @s if score @s afk.time_passed = @s afkTimeLimit run function cb_mod:afk_det/afk_result.necromancer
execute as @a[tag=necromancer.ability,tag=necromancer.afk] at @s run execute as @e[sort=nearest,distance=..1,tag=necromancer.afk_marker,limit=1] at @s run function cb_world:_particle/alchemymod6 
execute as @a[tag=necromancer.ability,tag=necromancer.afk] at @s run execute as @e[sort=nearest,distance=..1,tag=necromancer.afk_marker,limit=1] at @s run particle soul_fire_flame ^ ^0.5 ^1 0 0 0 0 1 force @a[scores={simple_particle_mode.boolean.true=1}]
execute as @a[tag=necromancer.ability,tag=necromancer.afk,scores={simple_particle_mode.boolean.true=1}] at @s run execute as @e[sort=nearest,distance=..1,tag=necromancer.afk_marker,limit=1] at @s run tp @s ~ ~ ~ facing ^0.2 ^ ^1
execute as @a[tag=necromancer.ability,tag=necromancer.afk,scores={simple_particle_mode.boolean.true=0}] at @s run execute as @e[sort=nearest,distance=..1,tag=necromancer.afk_marker,limit=1] at @s run tp @s ~ ~ ~ facing ^0.05 ^ ^1
execute as @a[tag=necromancer.ability,tag=necromancer.afk] at @s run effect give @s resistance 1 99 true
execute as @a[tag=necromancer.ability,tag=necromancer.afk] at @s run effect give @s weakness 1 99 true
execute as @a[tag=necromancer.ability,tag=necromancer.afk] at @s run effect give @s mining_fatigue 1 99 true

#Harmony Healer
execute as @a[tag=harmony_healer.ability] at @s run function cb_mod:afk_det/afk.harmony_healer
execute as @a[tag=harmony_healer.ability] at @s if score @s afk.time_passed = @s afkTimeLimit run function cb_mod:afk_det/afk_result.harmony_healer
execute as @a[tag=harmony_healer.ability,tag=harmony_healer.afk] at @s run execute as @e[sort=nearest,distance=..1,tag=harmony_healer.afk_marker,limit=1] at @s run particle note ^ ^0.5 ^1 0 0 0 1 1 force
execute as @a[tag=harmony_healer.ability,tag=harmony_healer.afk] at @s run execute as @e[sort=nearest,distance=..1,tag=harmony_healer.afk_marker,limit=1] at @s run tp @s ~ ~ ~ facing ^.4 ^ ^1
execute as @a[tag=harmony_healer.ability,tag=harmony_healer.afk] at @s run effect give @s resistance 1 99 true
execute as @a[tag=harmony_healer.ability,tag=harmony_healer.afk] at @s run effect give @s weakness 1 99 true
execute as @a[tag=harmony_healer.ability,tag=harmony_healer.afk] at @s run effect give @s mining_fatigue 1 99 true




## Double Jump (GENERIC)
tag @a[nbt={OnGround:1b},tag=djg.active,gamemode=!creative,gamemode=!spectator] add djb.nbt-ground
scoreboard players reset @a[nbt={OnGround:1b}] djg.SNEAK
execute if score #relative_world djg.gamerule_cooldown matches 1.. run scoreboard players remove #relative_world djg.gamerule_cooldown 1
execute if score #relative_world djg.gamerule_cooldown matches 0 run gamerule fallDamage true
execute if score #relative_world djg.gamerule_cooldown matches 0 run gamerule fireDamage true

#sound fix
execute as @a[scores={djg.SNEAK=1..},tag=djg.active,gamemode=!creative,gamemode=!spectator] at @s if block ~ ~-.3 ~ #minecraft:empty if entity @s[tag=djb.nbt-ground,nbt={OnGround:0b}] run function cb_mod:djg_/main
execute as @a[tag=!djb.nbt-ground,scores={djg.SNEAK=1..},tag=djg.active,gamemode=!creative,gamemode=!spectator] at @s run stopsound @a * minecraft:entity.creeper.primed
execute as @a[tag=!djb.nbt-ground,scores={djg.SNEAK=1..},tag=djg.active,gamemode=!creative,gamemode=!spectator] at @s run stopsound @a * minecraft:entity.creeper.death
execute as @a[tag=!djb.nbt-ground,scores={djg.SNEAK=1..},tag=djg.active,gamemode=!creative,gamemode=!spectator] at @s run stopsound @a * minecraft:entity.generic.explode
scoreboard players set @a[gamemode=!survival,gamemode=!adventure] djg.SNEAK 0

### El Fuego
##DEBUG
execute as @a[tag=el_fuego.ability,gamemode=!creative,tag=!requirements_set.] at @s run function cb_mod:abilities/el_fuego/requirements_settings
tag @a[tag=!el_fuego.ability,tag=requirements_set.] remove djg.active
clear @a[tag=!el_fuego.ability,tag=requirements_set.] #cb_client:guis/inventory_1/all{objd:{gui:{inventory1:1b}}}
clear @a[tag=el_fuego.ability,gamemode=!survival,gamemode=!adventure] #cb_client:guis/inventory_1/all{objd:{gui:{inventory1:1b}}}
tag @a[tag=!el_fuego.ability,tag=requirements_set.] remove requirements_set.
effect give @a[tag=el_fuego.ability] resistance 1 1 true
# Fire punch
execute as @a[advancements={cb_mod:abilities/el_fuego/fire_punch/activate=true}] at @s run function cb_mod:abilities/el_fuego/fire_punch/fire_punch.player
advancement revoke @a[advancements={cb_mod:abilities/el_fuego/fire_punch/activate=true}] only cb_mod:abilities/el_fuego/fire_punch/activate
execute as @a[nbt={SelectedItem:{tag:{cb_mod:"fire_punch"}}}] at @s run attribute @s generic.attack_knockback base set 10
execute as @a[nbt=!{SelectedItem:{tag:{cb_mod:"fire_punch"}}}] at @s run attribute @s generic.attack_knockback base set 0
execute as @a[scores={attack.fire_punch.cooldown=1..}] at @s run scoreboard players set @s attack.fire_punch.boolean 1
execute as @a[scores={attack.fire_punch.cooldown=..0}] at @s run scoreboard players set @s attack.fire_punch.boolean 0

execute as @a[scores={attack.fire_punch.cooldown=0..}] at @s run scoreboard players remove @s attack.fire_punch.cooldown 1
execute as @a[scores={attack.fire_punch.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2

scoreboard players remove @e[scores={attack.fire_punch.cooldown2=0..}] attack.fire_punch.cooldown2 1
scoreboard players set @e[type=!player] attack.fire_punch.cooldown2 0

# Flamed Step
execute as @e[tag=attack.flamed_step.C] at @s run function cb_mod:abilities/el_fuego/flamed_step/flamed_step.center
execute as @a[scores={attack.flamed_step.cooldown=1..}] at @s run scoreboard players set @s attack.flamed_step.boolean 1
execute as @a[scores={attack.flamed_step.cooldown=..0}] at @s run scoreboard players set @s attack.flamed_step.boolean 0
execute as @a[scores={attack.flamed_step.cooldown=0..}] at @s run scoreboard players remove @s attack.flamed_step.cooldown 1
execute as @a[scores={attack.flamed_step.effect_cooldown=0..}] at @s run scoreboard players remove @s attack.flamed_step.effect_cooldown 1
execute as @a[scores={attack.flamed_step.cooldown3=0..}] at @s run scoreboard players remove @s attack.flamed_step.cooldown3 1
execute as @a[scores={attack.flamed_step.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
execute as @a[scores={attack.flamed_step.effect_cooldown=0}] at @s run execute as @e[tag=script.point02,distance=..8,limit=24,sort=nearest] at @s run function .script:sort/nbt/motion
execute as @a[scores={attack.flamed_step.cooldown3=0}] at @s run function cb_mod:abilities/el_fuego/flamed_step/flamed_step.set_fire


#Fire Boom
scoreboard players set @a[scores={attack.fire_boom.cooldown=1..}] attack.fire_boom.boolean 1
scoreboard players set @a[scores={attack.fire_boom.cooldown=..0}] attack.fire_boom.boolean 0

scoreboard players add @e[tag=attack.fire_boom.MINE] attack.fire_boom.cooldown2 1
execute as @e[tag=attack.fire_boom.MINE] at @s if score @s attack.fire_boom.cooldown2 matches 1.. run data merge entity @s {transformation:{scale:[0.5f,0.5f,0.5f],translation:[.25f,0.0f,.25f]},Glowing:1b,glow_color_override:6684929}
execute as @e[tag=attack.fire_boom.MINE] at @s if score @s attack.fire_boom.cooldown2 matches 20 run playsound entity.experience_orb.pickup master @a ~ ~ ~ 90 1.4
execute as @e[tag=attack.fire_boom.MINE] at @s if score @s attack.fire_boom.cooldown2 matches 40 run playsound entity.experience_orb.pickup master @a ~ ~ ~ 90 1.5
execute as @e[tag=attack.fire_boom.MINE] at @s if score @s attack.fire_boom.cooldown2 matches 61.. align xyz positioned ~.5 ~ ~.5 run function cb_mod:abilities/el_fuego/fire_boom/fire_boom.entity 

execute as @e[tag=attack.fire_boom.MINE] at @s if score @s attack.fire_boom.cooldown2 matches 20 run data merge entity @s {CustomName:'{"text": "2","color":"yellow"}'}
execute as @e[tag=attack.fire_boom.MINE] at @s if score @s attack.fire_boom.cooldown2 matches 40 run data merge entity @s {CustomName:'{"text": "1","color":"red"}'}
execute as @e[tag=attack.fire_boom.DISPLAY] at @s run tp @s ~ ~ ~ facing ^0.3 ^ ^1
execute as @e[tag=attack.fire_boom.DISPLAY] at @s run particle flame ^ ^ ^.6
execute as @e[tag=attack.fire_boom.DISPLAY] at @s unless entity @e[tag=attack.fire_boom.MINE,distance=..2,sort=nearest] run kill @s

execute as @a[scores={attack.fire_boom.uses=3..},tag=!attack.fire_boom.loadC] at @s run scoreboard players set @s attack.fire_boom.cooldown 200
execute as @a[scores={attack.fire_boom.uses=3..},tag=!attack.fire_boom.loadC] at @s run tag @s add attack.fire_boom.loadC
scoreboard players remove @e[scores={attack.fire_boom.cooldown=0..}] attack.fire_boom.cooldown 1
scoreboard players remove @e[scores={attack.fire_boom.effect_cooldown=0..}] attack.fire_boom.effect_cooldown 1
execute as @a[scores={attack.fire_boom.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
execute as @a[scores={attack.fire_boom.cooldown=0}] at @s run tag @s remove attack.fire_boom.loadC
execute as @a[scores={attack.fire_boom.cooldown=0}] at @s run scoreboard players set @s attack.fire_boom.uses 0

#explosion dat
scoreboard players remove @e[scores={attack.fire_boom.explosion.dat1=0..}] attack.fire_boom.explosion.dat1 1
scoreboard players remove @e[scores={attack.fire_boom.explosion.dat2=0..}] attack.fire_boom.explosion.dat2 1
scoreboard players remove @e[scores={attack.fire_boom.explosion.dat3=0..}] attack.fire_boom.explosion.dat3 1
execute as @e[scores={attack.fire_boom.explosion.dat1=0}] at @s run execute as @e[tag=script.point02,distance=..8,sort=nearest,limit=50] at @s run tp @s ~ ~1 ~ facing entity @e[tag=attack.fire_boom.explosion_nbt,limit=1,sort=nearest]
execute as @e[scores={attack.fire_boom.explosion.dat1=0}] at @s run execute as @e[tag=script.point02,distance=..8,sort=nearest,limit=50] at @s run data merge entity @s {NoGravity:0b,Motion:[0.0d,0.1d,0.0d],DropItem:0b}
execute as @e[scores={attack.fire_boom.explosion.dat2=0}] at @s run execute as @e[tag=script.point02,distance=..8,sort=nearest,limit=1] at @s run summon creeper ^ ^ ^ {Fuse:0s,ignited:1,ExplosionRadius:2,Silent:1b,CustomName:'{"text": "an explosion"}'}
execute as @e[scores={attack.fire_boom.explosion.dat3=0}] at @s run summon fireball ~ ~.1 ~ {ExplosionPower:2,Motion:[0.0d,-2d,0.0d],CustomName:'{"text": "an explosion"}'}
execute as @e[scores={attack.fire_boom.explosion.dat3=..0}] at @s run kill @s
execute as @e[tag=attack.fire_boom.explosion_nbt,tag=!attack.fire_boom.set_explosion] at @s run function cb_mod:abilities/el_fuego/fire_boom/fire_boom.explosion_nbt
execute as @e[tag=attack.fire_boom.fireball] at @s run data merge entity @s {Motion:[0.0d,-1.d,0.0d]}


#Meteor Shower
scoreboard players set @a[scores={attack.meteor_shower.cooldown=1..}] attack.meteor_shower.boolean 1
scoreboard players set @a[scores={attack.meteor_shower.cooldown=..0}] attack.meteor_shower.boolean 0
execute as @a[scores={attack.meteor_shower.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2

scoreboard players set @e[type=!player] attack.meteor_shower.cooldown2 0

scoreboard players remove @a[scores={attack.meteor_shower.cooldown=0..}] attack.meteor_shower.cooldown 1
scoreboard players remove @a[scores={attack.meteor_shower.cooldown2=0..}] attack.meteor_shower.cooldown2 1


execute as @a[advancements={cb_mod:abilities/el_fuego/meteor_shower/activate=true},scores={attack.meteor_shower.cooldown=..0}] at @s run function cb_mod:abilities/el_fuego/meteor_shower/meteor_shower.player
execute as @e[tag=attack.meteor_shower.SEL] at @s run scoreboard players add @s attack.meteor_shower.sel_cooldown 1
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=1..}] at @s run effect give @s glowing 1 99 true
execute as @e[tag=!attack.meteor_shower.SEL] at @s run scoreboard players reset @s attack.meteor_shower.sel_cooldown

execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220}] at @s run execute anchored eyes positioned ^ ^-3 ^ facing ~ ~1 ~ run function cb_world:_particle/plot.flame_cilender_spiral
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220}] at @s run summon fireball ~ ~10 ~ {Motion:[0.0d,-1.0d,0.0d],ExplosionPower:2,Tags:[attack.meteor_shower.fireball]}
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220..}] at @s run team leave @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220..}] at @s run data merge entity @s {CustomName:'[{"text":"","bold": true,"color": "dark_red"}]',CustomNameVisible:1b}
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220..}] at @s run data remove entity @s CustomNameVisible
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220..}] at @s run effect clear @s glowing
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=220..}] at @s run tag @s remove attack.meteor_shower.SEL
execute as @e[scores={attack.meteor_shower.sel_cooldown=221..}] at @s run scoreboard players reset @s attack.meteor_shower.sel_cooldown

#explosion dat
execute as @e[tag=attack.meteor_shower.fireball] at @s run data merge entity @s {Motion:[0.0d,-1.d,0.0d]}
execute as @e[tag=attack.meteor_shower.fireball] at @s run execute unless block ~ ~-1 ~ #empty run execute align xyz run summon marker ~.5 ~ ~.5 {Tags:[attack.fire_boom.explosion_nbt]}



execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=1..40}] at @s run team join attack.meteor_shower.STAGE10 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=21..30}] at @s run team join attack.meteor_shower.STAGE10 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=31..40}] at @s run team join attack.meteor_shower.STAGE9 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=41..50}] at @s run team join attack.meteor_shower.STAGE9 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=51..60}] at @s run team join attack.meteor_shower.STAGE8 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=61..70}] at @s run team join attack.meteor_shower.STAGE8 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=71..80}] at @s run team join attack.meteor_shower.STAGE7 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=81..90}] at @s run team join attack.meteor_shower.STAGE7 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=91..100}] at @s run team join attack.meteor_shower.STAGE6 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=101..110}] at @s run team join attack.meteor_shower.STAGE6 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=111..120}] at @s run team join attack.meteor_shower.STAGE5 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=121..130}] at @s run team join attack.meteor_shower.STAGE5 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=131..140}] at @s run team join attack.meteor_shower.STAGE4 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=141..150}] at @s run team join attack.meteor_shower.STAGE4 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=151..160}] at @s run team join attack.meteor_shower.STAGE3 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=161..170}] at @s run team join attack.meteor_shower.STAGE3 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=171..180}] at @s run team join attack.meteor_shower.STAGE2 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=181..190}] at @s run team join attack.meteor_shower.STAGE2 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=191..200}] at @s run team join attack.meteor_shower.STAGE1 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=201..}] at @s run team join attack.meteor_shower.STAGE1 @s
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=20}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=40}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.1
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=60}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.2
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=80}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.3
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=100}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.4
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=120}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.5
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=140}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.6
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=160}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.7
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=180}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.8
execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=200}] at @s run playsound entity.experience_orb.pickup master @a[distance=..34] ~ ~ ~ 90 1.9

execute as @e[tag=attack.meteor_shower.SEL,scores={attack.meteor_shower.sel_cooldown=1..}] at @s run data merge entity @s {CustomName:'[{"text":"!","bold": true,"color": "dark_red"}]',CustomNameVisible:1b}


## Necromancer
##DEBUG
execute as @a[tag=necromancer.ability,gamemode=!creative,tag=!requirements_set.n] at @s run function cb_mod:abilities/necromancer/requirements_settings
tag @a[tag=!necromancer.ability,tag=requirements_set.n] remove djg.active
clear @a[tag=!necromancer.ability,tag=requirements_set.n] #cb_client:guis/inventory_2/all{objd:{gui:{inventory2:1b}}}
clear @a[tag=necromancer.ability,gamemode=!survival,gamemode=!adventure] #cb_client:guis/inventory_2/all{objd:{gui:{inventory2:1b}}}
tag @a[tag=!necromancer.ability,tag=requirements_set.n] remove requirements_set.n
effect give @a[tag=necromancer.ability] resistance 1 1 true
#telekinesis
execute as @a[scores={attack.telekinesis.cooldown=1..}] at @s run scoreboard players set @s attack.telekinesis.boolean 1
execute as @a[scores={attack.telekinesis.cooldown=..0}] at @s run scoreboard players set @s attack.telekinesis.boolean 0
execute as @a[scores={attack.telekinesis.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.telekinesis.cooldown=0..}] attack.telekinesis.cooldown 1
scoreboard players remove @e[scores={attack.telekinesis.cooldown2=0..}] attack.telekinesis.cooldown2 1

scoreboard players set @e[type=!player] attack.telekinesis.cooldown2 0

execute as @a[scores={attack.telekinesis.switch=1..},tag=!necromancer.ability] at @s run function cb_mod:abilities/necromancer/telekinesis/telekinesis.override
execute as @a[scores={attack.telekinesis.switch=1..},tag=necromancer.ability,nbt=!{SelectedItem:{tag:{cb_mod:"telekinesis"}}}] at @s run function cb_mod:abilities/necromancer/telekinesis/telekinesis.override
execute as @a[scores={attack.telekinesis.switch=1..},tag=necromancer.ability,nbt={SelectedItem:{tag:{cb_mod:"telekinesis"}}},predicate=!minecraft:flags/sneak] at @s run function cb_mod:abilities/necromancer/telekinesis/telekinesis.override
execute as @a[tag=necromancer.ability,scores={attack.telekinesis.sel_cooldown=200..}] at @s run function cb_mod:abilities/necromancer/telekinesis/telekinesis.override

execute as @a[scores={attack.telekinesis.switch=1}] at @s run function cb_mod:abilities/necromancer/telekinesis/telekinesis.active_stats

#blood curse
execute as @a[scores={attack.blood_curse.cooldown=1..}] at @s run scoreboard players set @s attack.blood_curse.boolean 1
execute as @a[scores={attack.blood_curse.cooldown=..0}] at @s run scoreboard players set @s attack.blood_curse.boolean 0
execute as @a[scores={attack.blood_curse.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.blood_curse.cooldown=0..}] attack.blood_curse.cooldown 1
scoreboard players remove @e[scores={attack.blood_curse.cooldown2=1..}] attack.blood_curse.cooldown2 1
scoreboard players remove @e[scores={attack.blood_curse.cooldown3=0..}] attack.blood_curse.cooldown3 1
scoreboard players set @e[type=!player] attack.blood_curse.cooldown2 0
execute as @e[scores={attack.blood_curse.cooldown3=1..}] at @s run tp @e[type=marker,tag=attack.blood_curse.curse_marker,limit=1,sort=nearest,distance=..1] ~ ~ ~

execute as @e[scores={attack.blood_curse.cooldown3=1..}] at @s unless score @s attack.blood_curse.randomize_v1 matches 5 run effect give @s glowing 1 99 true
execute as @e[scores={attack.blood_curse.cooldown3=1..}] at @s run team join attack.blood_curse.cursed_mob
execute as @e[scores={attack.blood_curse.cooldown3=1..}] at @s anchored feet run function cb_world:_particle/blood_curse
execute as @e[scores={attack.blood_curse.cooldown3=1..}] at @s anchored feet run function cb_world:_particle/alchemymod5
execute as @e[scores={attack.blood_curse.cooldown3=0}] at @s run function cb_mod:abilities/necromancer/blood_curse/blood_curse.end_curse
execute as @a[advancements={cb_mod:abilities/necromancer/blood_curse/activate=true},scores={attack.blood_curse.cooldown=..0}] at @s run function cb_mod:abilities/necromancer/blood_curse/blood_curse.player

#all curses
#1
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=1}] at @s run effect give @s weakness 1 99 true
#2
execute as @e[type=!player,scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=2}] at @s run effect give @s weakness 1 99 true
execute as @a[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=2}] at @s run effect give @s mining_fatigue 1 99 true
#3
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=3}] at @s run effect give @s slowness 1 4 true
#4
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=4}] at @s run tp @s @e[type=marker,limit=1,sort=nearest,distance=..1,tag=attack.blood_curse.lock_movement]
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=4}] at @s unless entity @e[type=marker,limit=1,sort=nearest,distance=..1,tag=attack.blood_curse.lock_movement] run summon marker ~ ~ ~ {Tags:[attack.blood_curse.lock_movement]}
execute as @e[type=marker,tag=attack.blood_curse.lock_movement] at @s unless entity @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=4}] run kill @s
#5
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=5}] at @s anchored eyes positioned ^ ^ ^ run particle dust 0 0 0 .6 ~ ~ ~ 0.2 0.2 0.2 0 250 force
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=5}] at @s anchored eyes positioned ^ ^ ^ run title @s title {"text": "\uE000","font": "cb_ui:overlays"}
#6
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=6}] at @s run attribute @s generic.max_health base set 1
#7
execute as @e[type=!player,scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=7}] at @s run effect give @s wither 1 4 true
execute as @a[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=7}] at @s run effect give @s wither 1 5 true
execute as @a[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=7}] at @s run attribute @s generic.armor base set -58932727483672893473
#8
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=8}] at @s unless block ~ ~ ~ water run damage @s 2 drown
#9
execute as @a[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=9},predicate=!minecraft:flags/sneak] at @s run damage @s 3 magic
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=9},nbt=!{Motion:[0.0d,0.0d,0.0d]}] at @s run damage @s 3 magic
#10
execute as @e[scores={attack.blood_curse.cooldown3=1..,attack.blood_curse.randomize_v1=10},predicate=minecraft:percentages/attack.blood_curse.variant_10] at @s run tp @s ~ ~ ~ facing ^0.5 ^.1 ^.7

#Mirage
execute as @a[scores={attack.mirage.cooldown=1..}] at @s run scoreboard players set @s attack.mirage.boolean 1
execute as @a[scores={attack.mirage.cooldown=..0}] at @s run scoreboard players set @s attack.mirage.boolean 0
execute as @a[scores={attack.mirage.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.mirage.cooldown=0..},gamemode=!spectator,gamemode=!creative] attack.mirage.cooldown 1
scoreboard players remove @e[scores={attack.mirage.cooldown2=0..},gamemode=!spectator,gamemode=!creative] attack.mirage.cooldown2 1

execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=1..}] at @s run scoreboard players set @s stat.necromancer.hat_off 1
execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=1..}] at @s run effect give @s invisibility 1 99 true
execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=1..}] at @s run effect give @s speed 1 1 true
execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=1..}] at @s run effect give @s strength 1 2 true
execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=1..}] at @s run attribute @s generic.max_health base set 10
execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=1..}] at @s run team join attack.mirage.visible_overlay @s
execute as @a[tag=necromancer.ability,scores={attack.mirage.cooldown2=0}] at @s run function cb_mod:abilities/necromancer/mirage/mirage.player.end

#Soul Exchange
execute as @a[scores={attack.soul_exchange.cooldown=1..}] at @s run scoreboard players set @s attack.soul_exchange.boolean 1
execute as @a[scores={attack.soul_exchange.cooldown=..0}] at @s run scoreboard players set @s attack.soul_exchange.boolean 0
execute as @a[scores={attack.soul_exchange.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.soul_exchange.cooldown=0..}] attack.soul_exchange.cooldown 1
scoreboard players remove @e[scores={attack.soul_exchange.cooldown2=1..}] attack.soul_exchange.cooldown2 1
scoreboard players remove @e[scores={attack.soul_exchange.sel_cooldown=0..}] attack.soul_exchange.sel_cooldown 1
scoreboard players remove @e[scores={attack.soul_exchange.direct_selector_cooldown=0..}] attack.soul_exchange.direct_selector_cooldown 1

execute as @e[scores={attack.soul_exchange.direct_selector_cooldown=1..},predicate=minecraft:flags/sneak] at @s run function cb_mod:abilities/necromancer/soul_exchange/soul_exchange.override
execute as @e[scores={attack.soul_exchange.sel_cooldown=0}] at @s run function cb_mod:abilities/necromancer/soul_exchange/soul_exchange.entity.end
execute as @e[scores={attack.soul_exchange.direct_selector_cooldown=0}] at @s run function cb_mod:abilities/necromancer/soul_exchange/soul_exchange.player.end
execute as @e[scores={attack.soul_exchange.sel_cooldown=1..}] at @s run effect give @s weakness 1 99 true

execute as @e[scores={attack.soul_exchange.sel_cooldown=-1}] at @s run scoreboard players reset @s attack.soul_exchange.sel_cooldown
scoreboard players set @e[type=!player] attack.soul_exchange.cooldown2 0

execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s unless entity @e[scores={attack.soul_exchange.sel_cooldown=1..},tag=attack.soul_exchange.current,limit=1,sort=nearest,distance=..2] run function cb_mod:abilities/necromancer/soul_exchange/soul_exchange.override
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s run tp @e[scores={attack.soul_exchange.sel_cooldown=1..},tag=attack.soul_exchange.current,limit=1,sort=nearest,distance=..2] @s
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s run team join attack.soul_exchange.no_collision
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s run effect give @s weakness 1 99 true
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s run effect give @s invisibility 1 99 true
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s run scoreboard players set @s stat.necromancer.hat_off 1
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s anchored feet run function cb_world:_particle/alchemymod7
execute as @e[tag=necromancer.ability,scores={attack.soul_exchange.direct_selector_cooldown=1..}] at @s anchored feet run function cb_world:_particle/soul_exchange

execute as @e[tag=attack.soul_exchange.current,type=!player] at @s run data merge entity @s {NoAI:1b}

##Harmony Healer
#DEBUG
execute as @a[tag=harmony_healer.ability,gamemode=!creative,tag=!requirements_set.hh] at @s run function cb_mod:abilities/harmony_healer/requirements_settings
tag @a[tag=!harmony_healer.ability,tag=requirements_set.hh] remove djg.active
clear @a[tag=!harmony_healer.ability,tag=requirements_set.hh] #cb_client:guis/inventory_3/all{objd:{gui:{inventory3:1b}}}
clear @a[tag=harmony_healer.ability,gamemode=!survival,gamemode=!adventure] #cb_client:guis/inventory_3/all{objd:{gui:{inventory3:1b}}}
tag @a[tag=!harmony_healer.ability,tag=requirements_set.hh] remove requirements_set.hh

#Resonance
execute as @a[scores={attack.resonance.cooldown=1..}] at @s run scoreboard players set @s attack.resonance.boolean 1
execute as @a[scores={attack.resonance.cooldown=..0}] at @s run scoreboard players set @s attack.resonance.boolean 0
execute as @a[scores={attack.resonance.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.resonance.cooldown=0..}] attack.resonance.cooldown 1
scoreboard players remove @e[scores={attack.resonance.cooldown2=1..}] attack.resonance.cooldown2 1
scoreboard players remove @e[scores={attack.resonance.text_scroll=0..}] attack.resonance.text_scroll 1
scoreboard players remove @e[scores={attack.resonance.cooldown3=0..}] attack.resonance.cooldown3 1
scoreboard players remove @e[scores={attack.resonance.effect_sound1=-5..}] attack.resonance.effect_sound1 1

execute as @e[scores={attack.resonance.text_scroll=40}] at @s run title @s actionbar {"text": "Resonating","color": "aqua"}
execute as @e[scores={attack.resonance.text_scroll=30}] at @s run title @s actionbar {"text": "Resonating.","color": "aqua"}
execute as @e[scores={attack.resonance.text_scroll=20}] at @s run title @s actionbar {"text": "Resonating..","color": "aqua"}
execute as @e[scores={attack.resonance.text_scroll=10}] at @s run title @s actionbar {"text": "Resonating...","color": "aqua"}
execute as @e[scores={attack.resonance.text_scroll=0}] at @s run scoreboard players set @s attack.resonance.text_scroll 41

execute as @e[scores={attack.resonance.effect_sound1=50}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 .9
execute as @e[scores={attack.resonance.effect_sound1=45}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1
execute as @e[scores={attack.resonance.effect_sound1=40}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.1
execute as @e[scores={attack.resonance.effect_sound1=35}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.2
execute as @e[scores={attack.resonance.effect_sound1=30}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.3
execute as @e[scores={attack.resonance.effect_sound1=25}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.4
execute as @e[scores={attack.resonance.effect_sound1=20}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.5
execute as @e[scores={attack.resonance.effect_sound1=15}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.6
execute as @e[scores={attack.resonance.effect_sound1=10}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.7
execute as @e[scores={attack.resonance.effect_sound1=5}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 1.9
execute as @e[scores={attack.resonance.effect_sound1=0}] at @s run playsound block.note_block.bit master @a ~ ~ ~ 1 2
execute as @e[scores={attack.resonance.cooldown3=1..}] at @s run function cb_mod:abilities/harmony_healer/resonance/resonance.active_stats
execute as @e[scores={attack.resonance.cooldown3=0}] at @s run function cb_mod:abilities/harmony_healer/resonance/resonance.stats.end
execute as @e[tag=attack.resonance.active_marker] at @s run particle note ^ ^1 ^1 0 0 0 1 1 force
execute as @e[tag=attack.resonance.active_marker] at @s run particle firework ^ ^1 ^1 0 0 0 0 1 force
execute as @e[tag=attack.resonance.active_marker] at @s run tp @s ~ ~ ~ facing ^.5 ^ ^1
execute as @e[tag=attack.resonance.active_marker] at @s unless entity @e[scores={attack.resonance.cooldown3=1..},sort=nearest,distance=..1] run kill @s

execute as @a[advancements={cb_mod:abilities/harmony_healer/resonance/activate=true},scores={attack.resonance.cooldown=..0}] at @s run function cb_mod:abilities/harmony_healer/resonance/resonance.player.hit
scoreboard players set @e[type=!player] attack.resonance.cooldown2 0

#Sound Blast
execute as @a[scores={attack.sound_blast.cooldown=1..}] at @s run scoreboard players set @s attack.sound_blast.boolean 1
execute as @a[scores={attack.sound_blast.cooldown=..0}] at @s run scoreboard players set @s attack.sound_blast.boolean 0
execute as @a[scores={attack.sound_blast.cooldown=0}] at @s run scoreboard players set @s attack.sound_blast.uses 0
execute as @a[scores={attack.sound_blast.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.sound_blast.cooldown=0..}] attack.sound_blast.cooldown 1
scoreboard players remove @e[scores={attack.sound_blast.cooldown2=1..}] attack.sound_blast.cooldown2 1
scoreboard players reset @e[scores={attack.sound_blast.projectile_cooldown=0}] attack.sound_blast.projectile_cooldown

scoreboard players set @e[type=!player] attack.sound_blast.cooldown2 0
execute as @e[tag=attack.sound_blast.projectile] at @s run function cb_mod:abilities/harmony_healer/sound_blast/sound_blast.raycast
execute as @e[tag=attack.sound_blast.projectile,scores={attack.sound_blast.projectile_cooldown=50..}] at @s run function cb_mod:abilities/harmony_healer/sound_blast/sound_blast.collision_block
execute as @e[tag=attack.sound_blast.projectile,scores={attack.sound_blast.projectile_cooldown=50..}] at @s run kill @s

execute as @a[scores={attack.sound_blast.uses=2..},tag=!attack.sound_blast.loadC] at @s run scoreboard players set @s attack.sound_blast.cooldown 500
execute as @a[scores={attack.sound_blast.uses=2..},tag=!attack.sound_blast.loadC] at @s run tag @s add attack.sound_blast.loadC
execute as @a[scores={attack.sound_blast.uses=0},tag=attack.sound_blast.loadC] at @s run tag @s remove attack.sound_blast.loadC

#explosion dat
scoreboard players remove @e[scores={attack.sound_blast.explosion.dat1=0..}] attack.sound_blast.explosion.dat1 1
scoreboard players remove @e[scores={attack.sound_blast.explosion.dat2=0..}] attack.sound_blast.explosion.dat2 1
execute as @e[scores={attack.sound_blast.explosion.dat1=0}] at @s run execute as @e[tag=script.point02,distance=..8,sort=nearest,limit=50] at @s run tp @s ~ ~1 ~ facing entity @e[tag=attack.sound_blast.explosion_nbt,limit=1,sort=nearest]
execute as @e[scores={attack.sound_blast.explosion.dat1=0}] at @s run execute as @e[tag=script.point02,distance=..8,sort=nearest,limit=50] at @s run data merge entity @s {NoGravity:0b,Motion:[0.0d,0.1d,0.0d],DropItem:0b}
execute as @e[scores={attack.sound_blast.explosion.dat2=0}] at @s run execute as @e[tag=script.point02,distance=..8,sort=nearest,limit=1] at @s run summon creeper ^ ^ ^ {Fuse:0s,ignited:1,ExplosionRadius:2,Silent:1b,CustomName:'{"text": "a sound wave"}'}
execute as @e[scores={attack.sound_blast.explosion.dat2=..0}] at @s run kill @s
execute as @e[tag=attack.sound_blast.explosion_nbt,tag=!attack.sound_blast.set_explosion] at @s run function cb_mod:abilities/harmony_healer/sound_blast/sound_blast.explosion_nbt

#Echolocation
execute as @a[scores={attack.echolocation.cooldown=1..}] at @s run scoreboard players set @s attack.echolocation.boolean 1
execute as @a[scores={attack.echolocation.cooldown=..0}] at @s run scoreboard players set @s attack.echolocation.boolean 0
execute as @a[scores={attack.echolocation.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.echolocation.cooldown=0..}] attack.echolocation.cooldown 1
scoreboard players remove @e[scores={attack.echolocation.cooldown2=1..}] attack.echolocation.cooldown2 1
scoreboard players remove @e[scores={attack.echolocation.sel_cooldown=1..}] attack.echolocation.sel_cooldown 1

scoreboard players set @e[type=!player] attack.echolocation.cooldown2 0
execute as @e[scores={attack.echolocation.sel_cooldown=1..}] at @s run function cb_mod:abilities/harmony_healer/echolocation/echolocation.entity
execute as @e[scores={attack.echolocation.sel_cooldown=0}] at @s run function cb_mod:abilities/harmony_healer/echolocation/echolocation.entity.end

#music player
execute as @a[scores={attack.music_player.cooldown=1..}] at @s run scoreboard players set @s attack.music_player.boolean 1
execute as @a[scores={attack.music_player.cooldown=..0}] at @s run scoreboard players set @s attack.music_player.boolean 0
execute as @a[scores={attack.music_player.cooldown=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 90 2
scoreboard players remove @e[scores={attack.music_player.cooldown=0..}] attack.music_player.cooldown 1

execute as @a[scores={music.weak.cooldown_starter=1..}] at @s run scoreboard players remove @s music.weak.cooldown_starter 1
execute if score #all_entities music.weak.cooldown matches 1.. run scoreboard players remove #all_entities music.weak.cooldown 1
execute if score #all_entities music.weak.cooldown matches 1.. run execute as @e[type=!#not_mob,tag=!djg.,tag=!sound_blast.projectile,tag=!attack.sound_blast.explosive] at @s unless score @s music.weak.cooldown_starter matches 1.. run effect give @s weakness 1 99 true
execute if score #all_entities music.weak.cooldown matches ..0 run scoreboard players reset #all_entities

execute as @a[scores={music.slow.cooldown_starter=1..}] at @s run scoreboard players remove @s music.slow.cooldown_starter 1
execute if score #all_entities music.slow.cooldown matches 1.. run scoreboard players remove #all_entities music.slow.cooldown 1
execute if score #all_entities music.slow.cooldown matches 1.. run execute as @e[type=!#not_mob,tag=!djg.,tag=!sound_blast.projectile,tag=!attack.sound_blast.explosive] at @s unless score @s music.slow.cooldown_starter matches 1.. run effect give @s slowness 1 2 true
execute if score #all_entities music.slow.cooldown matches ..0 run scoreboard players reset #all_entities

execute as @a[scores={music.blind.cooldown_starter=1..}] at @s run scoreboard players remove @s music.blind.cooldown_starter 1
execute if score #all_entities music.blind.cooldown matches 1.. run scoreboard players remove #all_entities music.blind.cooldown 1
execute if score #all_entities music.blind.cooldown matches 1.. run execute as @e[type=!#not_mob,tag=!djg.,tag=!sound_blast.projectile,tag=!attack.sound_blast.explosive] at @s unless score @s music.blind.cooldown_starter matches 1.. run effect give @s darkness 2 2 true
execute if score #all_entities music.blind.cooldown matches ..0 run scoreboard players reset #all_entities

execute as @a[scores={music.fatigue.cooldown_starter=1..}] at @s run scoreboard players remove @s music.fatigue.cooldown_starter 1
execute if score #all_entities music.fatigue.cooldown matches 1.. run scoreboard players remove #all_entities music.fatigue.cooldown 1
execute if score #all_entities music.fatigue.cooldown matches 1.. run execute as @e[type=!#not_mob,tag=!djg.,tag=!sound_blast.projectile,tag=!attack.sound_blast.explosive] at @s unless score @s music.fatigue.cooldown_starter matches 1.. run effect give @s mining_fatigue 2 2 true
execute if score #all_entities music.fatigue.cooldown matches ..0 run scoreboard players reset #all_entities

execute as @a[scores={music.no_regen.cooldown_starter=1..}] at @s run scoreboard players remove @s music.no_regen.cooldown_starter 1
execute if score #all_entities music.no_regen.cooldown matches 1.. run scoreboard players remove #all_entities music.no_regen.cooldown 1
execute if score #all_entities music.no_regen.cooldown matches 1.. run gamerule naturalRegeneration false
execute if score #all_entities music.no_regen.cooldown matches 0 run gamerule naturalRegeneration true
execute if score #all_entities music.no_regen.cooldown matches ..0 run scoreboard players reset #all_entities


##ITEMS
#Ability Token
execute as @a[scores={item.ability_token.use=1..},nbt={SelectedItem:{tag:{cb_item:{id:"cb:ability_token",tag:{"type":"empty"}}}}},predicate=minecraft:flags/sneak] at @s anchored eyes positioned ^ ^ ^ run function cb_vanilla:item/ability_token/raycast

execute as @a[scores={item.ability_token.use=1..},nbt={SelectedItem:{tag:{cb_item:{id:"cb:ability_token",tag:{"type":"harmony_healer"}}}}}] at @s anchored eyes positioned ^ ^ ^ run function cb_vanilla:item/ability_token/raycast/harmony_healer
execute as @a[scores={item.ability_token.use=1..},nbt={SelectedItem:{tag:{cb_item:{id:"cb:ability_token",tag:{"type":"necromancer"}}}}}] at @s anchored eyes positioned ^ ^ ^ run function cb_vanilla:item/ability_token/raycast/necromancer
execute as @a[scores={item.ability_token.use=1..},nbt={SelectedItem:{tag:{cb_item:{id:"cb:ability_token",tag:{"type":"el_fuego"}}}}}] at @s anchored eyes positioned ^ ^ ^ run function cb_vanilla:item/ability_token/raycast/el_fuego
execute as @a[scores={item.ability_token.use=1..},nbt={SelectedItem:{tag:{cb_item:{id:"cb:ability_token",tag:{"type":"vex"}}}}},predicate=!flags/sneak] at @s anchored eyes positioned ^ ^ ^ run function cb_vanilla:item/ability_token/raycast/trapped_soul
scoreboard players remove @e[scores={item.ability_token.use=1..}] item.ability_token.use 1

##BLOCKS
#Rune
execute as @e[tag=cb_vanilla.block.rune_placer] at @s if block ~ ~ ~ #custom_block_placeble run function cb_vanilla:blocks/engraved_basalt/rune/place
execute as @e[tag=cb_vanilla.block.rune_placer] at @s unless block ~ ~ ~ #custom_block_placeble run function cb_vanilla:blocks/engraved_basalt/rune/fix
execute as @e[tag=cb_vanilla.block.rune] at @s unless block ~ ~ ~ netherite_block run function cb_vanilla:blocks/engraved_basalt/rune/remove

execute as @e[tag=cb_vanilla.block.rune] at @s run playsound block.beacon.ambient master @a ~ ~ ~ 0.01
execute as @e[tag=cb_vanilla.block.rune_display] at @s run tp @s ~ ~ ~ facing ^.01 ^ ^1
execute as @e[tag=cb_vanilla.block.rune_display,tag=cb_vanilla.active_fire] at @s positioned ~ ~-.7 ~ run function cb_world:_particle/alchemymod9
execute as @e[tag=cb_vanilla.block.rune_display,tag=cb_vanilla.active_sound] at @s positioned ~ ~-.7 ~ run function cb_world:_particle/alchemymod8
execute as @e[tag=cb_vanilla.block.rune_display,tag=cb_vanilla.active_cursed] at @s positioned ~ ~-.7 ~ run function cb_world:_particle/alchemymod6


execute as @e[tag=cb_vanilla.block.rune,tag=cb.time_day] at @s if score #relative_world default.day_time matches 13000..23999 run execute align xyz run summon item_frame ~.5 ~ ~.5 {Tags:["cb_vanilla.block.rune","cb.time_night"],Item:{Count:1b,id:"minecraft:item_frame",tag:{CustomModelData:1210033}},Fixed:1b,Invisible:1b,Invulnerable:1b}
execute as @e[tag=cb_vanilla.block.rune,tag=cb.time_day] at @s if score #relative_world default.day_time matches 13000..23999 run kill @s

execute as @e[tag=cb_vanilla.block.rune,tag=cb.time_night] at @s if score #relative_world default.day_time matches 0..12999 run execute align xyz run summon glow_item_frame ~.5 ~ ~.5 {Tags:["cb_vanilla.block.rune","cb.time_day"],Item:{Count:1b,id:"minecraft:item_frame",tag:{CustomModelData:1210033}},Fixed:1b,Invisible:1b,Invulnerable:1b}
execute as @e[tag=cb_vanilla.block.rune,tag=cb.time_night] at @s if score #relative_world default.day_time matches 0..12999 run kill @s

#SOULINGS
execute as @e[tag=cb_vanilla.souling] at @s run particle end_rod ~ ~ ~
execute as @e[tag=cb_vanilla.souling] at @s run data merge entity @s {Silent:1b}
execute as @e[tag=cb_vanilla.souling] at @s run effect give @s slowness infinite 99 true
execute as @e[tag=cb_vanilla.souling] at @s run effect give @s invisibility infinite 99 true
execute as @e[tag=cb_vanilla.souling] at @s run effect give @s slow_falling infinite 99 true
execute as @e[tag=cb_vanilla.souling] at @s run playsound ambient.nether_wastes.loop master @a[distance=..5] ~ ~ ~ .3
execute as @e[tag=cb_vanilla.souling] at @s if entity @a[distance=..1.5] if predicate percentages/entity.souling_spawn_vex run summon vex
execute as @e[tag=cb_vanilla.souling] at @s if entity @a[distance=..1.5] run playsound entity.ghast.ambient master @a ~ ~ ~ .2
execute as @e[tag=cb_vanilla.souling] at @s if entity @a[distance=..1.5] run kill @s
execute as @e[tag=cb_vanilla.souling] at @s unless block ~ ~-.5 ~ #empty run function cb_world:_particle/plot.end_rod_circle 
execute as @e[tag=cb_vanilla.souling] at @s unless block ~ ~-.5 ~ #empty if predicate percentages/entity.souling_spawn_vex run summon vex
execute as @e[tag=cb_vanilla.souling] at @s unless block ~ ~-.5 ~ #empty run playsound entity.ghast.ambient master @a ~ ~ ~ .5
execute as @e[tag=cb_vanilla.souling] at @s unless block ~ ~-.5 ~ #empty run kill @s

#Engraved Basalt
execute as @e[tag=cb_vanilla.block.engraved_basalt_placer] at @s if block ~ ~ ~ #custom_block_placeble run function cb_vanilla:blocks/engraved_basalt/place
execute as @e[tag=cb_vanilla.block.engraved_basalt_placer] at @s unless block ~ ~ ~ #custom_block_placeble run function cb_vanilla:blocks/engraved_basalt/fix
execute as @e[tag=cb_vanilla.block.engraved_basalt] at @s unless block ~ ~ ~ basalt run function cb_vanilla:blocks/engraved_basalt/remove

execute as @e[tag=cb_vanilla.block.engraved_basalt,tag=cb.time_day] at @s if score #relative_world default.day_time matches 13000..23999 run execute align xyz run summon item_frame ~.5 ~ ~.5 {Tags:["cb_vanilla.block.engraved_basalt","cb.time_night"],Item:{Count:1b,id:"minecraft:item_frame",tag:{CustomModelData:1210031}},Fixed:1b,Invisible:1b,Invulnerable:1b}
execute as @e[tag=cb_vanilla.block.engraved_basalt,tag=cb.time_day] at @s if score #relative_world default.day_time matches 13000..23999 run kill @s

execute as @e[tag=cb_vanilla.block.engraved_basalt,tag=cb.time_night] at @s if score #relative_world default.day_time matches 0..12999 run execute align xyz run summon glow_item_frame ~.5 ~ ~.5 {Tags:["cb_vanilla.block.engraved_basalt","cb.time_day"],Item:{Count:1b,id:"minecraft:item_frame",tag:{CustomModelData:1210031}},Fixed:1b,Invisible:1b,Invulnerable:1b}
execute as @e[tag=cb_vanilla.block.engraved_basalt,tag=cb.time_night] at @s if score #relative_world default.day_time matches 0..12999 run kill @s

execute as @a[tag=harmony_healer.ability,predicate=flags/sneak] at @s if entity @e[tag=cb_vanilla.block.engraved_basalt,limit=1,sort=nearest,distance=..1] run execute as @e[tag=cb_vanilla.block.engraved_basalt,limit=1,sort=nearest,distance=..2] at @s run function cb_mod:abilities/harmony_healer/release
execute as @a[tag=necromancer.ability,predicate=flags/sneak] at @s if entity @e[tag=cb_vanilla.block.engraved_basalt,limit=1,sort=nearest,distance=..1] run execute as @e[tag=cb_vanilla.block.engraved_basalt,limit=1,sort=nearest,distance=..2] at @s run function cb_mod:abilities/necromancer/release
execute as @a[tag=el_fuego.ability,predicate=flags/sneak] at @s if entity @e[tag=cb_vanilla.block.engraved_basalt,limit=1,sort=nearest,distance=..1] run execute as @e[tag=cb_vanilla.block.engraved_basalt,limit=1,sort=nearest,distance=..2] at @s run function cb_mod:abilities/el_fuego/release

execute as @a[tag=el_fuego.ability,tag=necromancer.ability] run tag @s remove necromancer.ability
execute as @a[tag=el_fuego.ability,tag=harmony_healer.ability] run tag @s remove harmony_healer.ability

execute as @a[tag=necromancer.ability,tag=el_fuego.ability] run tag @s remove el_fuego.ability
execute as @a[tag=necromancer.ability,tag=harmony_healer.ability] run tag @s remove harmony_healer.ability

execute as @a[tag=harmony_healer.ability,tag=el_fuego.ability] run tag @s remove el_fuego.ability
execute as @a[tag=harmony_healer.ability,tag=necromancer.ability] run tag @s remove necromancer.ability

#GUIDE BOOK
execute as @e[type=item,nbt={Item:{tag:{cb_item:{id:"cb:guide_book"}}}}] at @s run playsound entity.item.pickup master @a ~ ~ ~
execute as @e[type=item,nbt={Item:{tag:{cb_item:{id:"cb:guide_book"}}}}] at @s run kill @s

